unit PingThread;

interface

uses
  Windows, Classes, BWGraphs, ICMP;

type
  TPingThread = class(TThread)
  private
    res : integer;
  protected
    procedure Execute; override;
    procedure Report;
  public
    Address : string;
    Graph   : TBWGraph;
    Timeout  : integer;
    DataSize : integer;
  published
    property Terminated;
  end;

implementation

{ TPingThread }

procedure TPingThread.Report;
begin
  Graph.DataList[0].AddValue(res);
  Graph.Repaint;
end;

procedure TPingThread.Execute;
var xPing: TICMP;
begin
 try
  xPing:=TICMP.Create;
  xPing.Address := Address;
  xPing.Timeout := Timeout;
  xPing.Size := DataSize;
  res:=xPing.Ping;
  if (res<>0) then res := xPing.Reply.RTT else res:=-1;
  //Sleep(2000);
  Synchronize(report);
  xPing.Free;
 except
  xPing.Free;
 end;
end;

end.
